<template>
  <header
    class="z-[60]"
    ref="headEl"
    :style="`--header-height: ${headElHeight}px`"
  >
    <div class="top-part z-[60]">
      <div class="info">
        <div class="left">
          <nuxt-link v-if="isPeruShopEnabled">
            <img :src="getAssetImage('assets/common/global_peru.png')" alt="568win-Logo" class="logo"/>
          </nuxt-link>
          <div class="flex justify-center items-center mx-2" v-if="isPeruShopEnabled">
            <button class="x-logo"></button>
          </div>
          <nuxt-link
            v-if="logo && !logo.IsHidden"
            :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'"
          >
            <img :src="logo.ImagePath" class="logo"/>
          </nuxt-link>
          <div class="divider" v-if="!isPeruShopEnabled"></div>
          <template v-if="isAuth">
            <div v-if="isAuth" class="flex gap-4 account-info" style="color: var(--text3)">
              <span v-if="!isPeruShopEnabled">{{ store.state.username }}</span>
              <lazy-wallet-info-global v-if="isAuth && (!isPeruShopEnabled || $route.path.startsWith('/games'))" />
            </div>
            <div class="divider" v-if="!isPeruShopEnabled && !isHiddenDepostWithdrawal"></div>
            <nuxt-link to="?uc=/deposit" class="header-btn bg-secondary uppercase" v-if="!isPeruShopEnabled && !isHiddenDepostWithdrawal" :id="ID.DEPOSIT_HEADER_DESKTOP">
              {{ $t(`deposit${isBhinbhin}`) }}
            </nuxt-link>
            <!-- <nuxt-link to="?uc=/deposit" class="header-btn bg-secondary uppercase" v-if="isPeruShopEnabled">
              {{ $t("Peru") }}
            </nuxt-link> -->
          </template>
          <template v-else>
            <div class="flex gap-2">
              <nuxt-link
                v-if="isDesktop"
                to="/login"
                class="header-btn bg-secondary"
              >
                {{ $t("capital_login") }}
              </nuxt-link>
              <nuxt-link
                v-if="!register.IsHidden && isDesktop"
                to="/register"
                class="header-btn bg-primary"
                :id="ID.SIGNUP"
              >
                {{ $t("joinnow") }}
              </nuxt-link>
              <nuxt-link
                v-if="!agentCooperation.IsHidden"
                to="/agent-cooperation"
                class="header-btn bg-primary uppercase agent-info"
              >
                {{ $t("agent_cooperation") }}
              </nuxt-link>
            </div>
          </template>
        </div>
        <div class="right">
          <language-global v-if="isDesktop" />
          <div v-if="isDesktop" class="divider"></div>
          <div v-if="isDesktop" class="time-block">
            <span>{{ datetimeDisplay }}</span>
          </div>

          <div class="divider" v-if="!isPeruShopEnabled"></div>
          <SwitchCommon
            v-if="!isPeruShopEnabled"
            :is-showlabel="true"
            v-model:is-dark="isDarkMode"
          />
          <template v-if="!isPeruShopEnabled && isAuth">
            <div class="divider"></div>
            <theme-desktop-global-components-menu-drawer/>
          </template>
        </div>
      </div>
    </div>
    <theme-desktop-global-components-header-nav
     :is-peru-shop-enabled="isPeruShopEnabled"
    />
  </header>
  <qr-code-modal :isShowQrCodePopup="isShowQrCodePopup" :PayoutInfo="PayoutInfo" :on-before-close="() => isShowQrCodePopup = false" @closeModal="() => isShowQrCodePopup = false"/>
</template>

<script setup lang="ts">
import {
  IThemePropertiesFromApi,
  ThemePropertiesFromApiDto,
} from "~~/models/companyThemePropertiesRespone";
import { useDisplayLocalTime } from "@/composables/useTheme";
import { store } from "~~/store";
import commonHelper from '../../utils/commonHelper';
import useSportQrCode from '@/composables/useSportQrCode';
import { onMounted } from 'vue';
import { EnumSelectedThemeMode } from "~~/models/enums/enumSelectedThemeMode";

const { getAssetImage, isBhinbhin } = commonHelper;
const isAuth = computed(() => store.state.auth);
const isDesktop = useIsDesktop();
const headEl = ref();
const headElHeight = ref<number>(106);
const { isShowQrCodePopup, PayoutInfo, showQrCodePopup } = useSportQrCode();
const logo = computed(() => {
  const found = store.state.companyThemePropertiesFromApi.ThemeProperties.find(
    (property) => property.HtmlId === "logo"
  );
  if (!found) return undefined;
  return new ThemePropertiesFromApiDto(found);
});
const register = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      store.state.companyThemePropertiesFromApi.ThemeProperties,
      "register"
    )
);
const dimension = useResponsiveDimensions();
const isDarkMode = ref(store.state.selectedThemeMode === EnumSelectedThemeMode.Dark);
const isPeruShopEnabled = computed(() => store.state.isPerushopEnabled);
watch(
  () => dimension.sizes.width,
  () => {
    nextTick(() => {
      setTimeout(() => {
        if (headEl.value && headEl.value.clientHeight) {
          headElHeight.value = headEl.value.clientHeight;
        } else {
          headElHeight.value = 106;
        }
      }, 1000);
    });
  },
  { deep: true, immediate: true }
);
const agentCooperation = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      store.state.companyThemePropertiesFromApi.ThemeProperties,
      "agent_cooperation"
    )
);
const { datetimeDisplay } = useDisplayLocalTime();
const receiveMessage = (event: MessageEvent) => {
  if (event.data === "placeBet") {
    if (isPeruShopEnabled.value === true) {
      showQrCodePopup();
    }
  }
};
onMounted(() => {
  window.addEventListener('message', receiveMessage);
});
const isHiddenDepostWithdrawal = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      store.state.companyThemePropertiesFromApi.ThemeProperties,
      "deposit_withdraw"
    ).IsHidden
);
</script>

<style scoped>
header {
  display: flex;
  flex-direction: column;
  align-items: center;
}
.top-part {
  display: flex;
  padding: 0 16px;
  flex-direction: column;
  align-items: center;
  gap: 12px;
  align-self: stretch;
  background: var(--background3, #05061e);
}

header .info {
  display: flex;
  justify-content: space-between;
  align-items: center;
  align-self: stretch;
  height: 64px;
}

header .logo {
  width: 168px;
  height: 56px;
  min-width: 96px;
  max-width: 168px;
  object-fit: contain;
}

header .left,
header .right {
  display: flex;
  align-items: center;
  gap: 16px;
}

.divider {
  width: 1px;
  height: 32px;
  background: var(--border, #4d5080);
}

header .header-btn {
  padding: 8px 16px;
  border-radius: 4px;
  color: var(--text5);
  text-align: center;
  font-size: 14px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
}

header .header-btn .bg-secondary {
  background-color: var(--secondary);
}

header .header-btn .bg-primary {
  background-color: var(--primary);
}

header .time-block {
  display: flex;
  height: 32px;
  padding: 8px 12px;
  align-items: center;
  gap: 8px;
  border-radius: 8px;
  background: linear-gradient(0deg, rgba(0, 0, 0, 0) 0%, rgba(0, 0, 0, 0) 100%),
    var(--background5, #1d2052);
  color: var(--text5, #fff);
  text-align: center;
  font-size: 12px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
  text-transform: uppercase;
}
</style>
<style lang="scss">
[theme-color="global_light_01"] {
  .account-info {
    color: var(--text3) !important;
  }
  .agent-info {
    background: var(--tertiary) !important;
  }
  .header-btn {
    color: var(--textBtn) !important;
  }
}
</style>